template <typename Type> class TArr : public ts::TExtData {

  bool isMobile;
  Type *data;

public:
  TArr() : isMobile(false), data(NULL) {}

  void TArr::clear() { if (!isMobile && data) free(data); }

  Type* getData() { return isMobile ? (Type*)extData() : data; }

  operator Type* () { return getData(); }
  operator const Type* () const { return ((TArr<Type>*)this)->getData(); }

  Type* alloc (long size){
    assert(!isMobile);
    clear();

    data = (Type*)malloc(sizeof(Type)*size);
    extDataSize() = size * sizeof(Type);

    return getData();
  }

  uint getSize(){
    return extDataSize()/sizeof(Type);
  }

  TArr (const TArr<Type>& ts) : isMobile(true) {
    TArr<Type> &s = (TArr<Type>&)ts;
    //    printf("--------------> Copy constructor\n");
    if ((data = s) != NULL){
      for (uint i=0; i<extDataSize()/sizeof(Type); i++){
	(*this)[i] = s[i];
      }
    }
  }

  TArr::~TArr() {
    clear();
  }

};

